/******************************************************************************
;	localiksend.h
******************************************************************************/
#ifndef _LOCALIKSEND_H_
#define _LOCALIKSEND_H_

#include <windows.h>
#include "MQBasePlugin.h"
#include "MQ3DLib.h"

#pragma warning( disable: 4996 )

/******************************************************************************
;	struct
******************************************************************************/
//vOCID
#define	LOCALIK_PLUGIN_PRODUCT					0x83F65102				//v_NgID
#define	LOCALIK_PLUGIN_ID						0x9BC40d19				//vOCID
//bZ[WR}h
#define	LOCALIKCMD_GETMORPHTARGETMAX			"GetMorphTargetMax"				//[t^[Qbg̍ő吔𓾂
#define	LOCALIKCMD_HASANYMORPHTARGET			"HasAnyMorphTarget"				//烂[t^[Qbg邩?
#define	LOCALIKCMD_HASMORPHTARGET				"HasMorphTarget"				//[t^[Qbg邩?
#define	LOCALIKCMD_SETMORPHTARGET				"SetMorphTarget"				//[t^[Qbg̎w
#define	LOCALIKCMD_GETMORPHTARGET				"GetMorphTarget"				//[t^[Qbg̊l
#define	LOCALIKCMD_SETMORPHTARGETPOSARRAY		"SetMorphTargetPosArray"		//[t^[Qbg̈ʒuw
#define	LOCALIKCMD_GETMORPHTARGETPOSARRAY		"GetMorphTargetPosArray"		//[t^[Qbg̈ʒul
#define	LOCALIKCMD_GETCURRENTMORPHTARGETINDEX	"GetCurrentMorphTargetIndex"	//Jg[t^[QbgIndexl
#define	LOCALIKCMD_GETBASEMORPHTARGETPOSARRAY	"GetBaseMorphTargetPosArray"	//x[X[t^[Qbg̒_ʒu𓾂
#define	LOCALIKCMD_GETVERTEXWEIGHTMAX			"GetVertexWeightMax"			//_EFCg̍ő吔𓾂
#define	LOCALIKCMD_HASVERTEXWEIGHT				"HasVertexWeight"				//_EFCg邩?
#define	LOCALIKCMD_SETVERTEXWEIGHTARRAY			"SetVertexWeightArray"			//_EFCg̐ݒ
#define	LOCALIKCMD_GETVERTEXWEIGHTARRAY			"GetVertexWeightArray"			//_EFCg̊l


//==============================================
//_EFCg̃^[QbgƃEFCgl̍\
struct LocalIKMessage_VertexWeightOne{
	int obj_id;								//^[Qbg̃IuWFNgID(MQObject::GetUniqueID()̒l)
	float weight;							//EFCg(0.0`1.0)
};

//==============================================
//1_̒_EFCg̍\
struct LocalIKMessage_VertexWeight{
	int num;									//^[Qbg̐
	LocalIKMessage_VertexWeightOne tbl[1];		//^[Qbg̃e[u(LocalIKMessage_VertexWeightArrayŊmۂvertexweight_max̐)
public:
	inline LocalIKMessage_VertexWeight(){
		num=0;
	}
	//1_̒_EFCg̃TCY
	//vertexweight_max		1_̒_EFCg̃^[Qbg̍ő吔
	inline static size_t GetSize(int vertexweight_max){
		return sizeof(LocalIKMessage_VertexWeight)+(sizeof(LocalIKMessage_VertexWeightOne)*(vertexweight_max-1));
	}
};

//==============================================
//_EFCgXg̍\
struct LocalIKMessage_VertexWeightArray{
private:
	void *vwarray;								//_EFCgXg(_)AڃANZXsAGetVertexWeightg
public:
	int vertexweight_max;						//1_̒_EFCg̃^[Qbg̍ő吔
	int vertex_num;								//_
public:
	inline LocalIKMessage_VertexWeightArray(){
		vwarray=NULL;
		vertexweight_max=0;
		vertex_num=0;
	}
	//vertex_num			_
	//vertexweight_max		1_̒_EFCg̃^[Qbg̍ő吔
	inline LocalIKMessage_VertexWeightArray(int _vertex_num,int _vertexweight_max){
		vwarray=NULL;
		vertexweight_max=0;
		vertex_num=0;
		Alloc(_vertex_num,_vertexweight_max);
	}
	inline virtual ~LocalIKMessage_VertexWeightArray(){
		Free();
	}
	//1_̒_EFCg̃TCY
	inline size_t GetOneSize(void) const {
		return LocalIKMessage_VertexWeight::GetSize(vertexweight_max);
	}
	//vertex_num			_
	//vertexweight_max		1_̒_EFCg̃^[Qbg̍ő吔
	inline BOOL Alloc(int _vertex_num,int _vertexweight_max){
		Free();
		if(_vertex_num<=0)return FALSE;
		if(_vertexweight_max<=0)return FALSE;
		vertexweight_max=_vertexweight_max;
		vertex_num      =_vertex_num;
		size_t one_size=GetOneSize();
		size_t size=one_size*vertex_num;
		vwarray=malloc(size);
		for(size_t i=0;i<(size_t)vertex_num;i++){
			LocalIKMessage_VertexWeight *vw=GetVertexWeight(i);
			new(vw) LocalIKMessage_VertexWeight();
		}
		return TRUE;
	}
	//J(fXgN^ŎIɊJ)
	inline void Free(void){
		if(vwarray){
			free(vwarray);
			vwarray=NULL;
			vertex_num=0;
		}
	}
	//w̃CfbNX̒_EFCg̃|C^Ԃ
	inline LocalIKMessage_VertexWeight *GetVertexWeight(int i) const {
		if(i<0 || i>=vertex_num)return NULL;
		size_t one_size=GetOneSize();
		return (LocalIKMessage_VertexWeight *)((size_t)vwarray+(one_size*i));
	}
};

//==============================================
//[t^[Qbgő吔l
struct LocalIKMessage_GetMorphTargetMax{
	//(Ȃ)
	//o
	int morph_max;							//[tIndex
};
//[t^[Qbgő吔l
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//o)	Ԃl				TRUE:AFALSE:s
//		morph_max			[t^[Qbg̍ől
static BOOL LocalIKCmd_GetMorphTargetMax(MQBasePlugin *bp,MQDocument doc,int &morph_max){
	LocalIKMessage_GetMorphTargetMax param;
	if(!bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETMORPHTARGETMAX,&param))return FALSE;
	return TRUE;
}
//==============================================
//w̃IuWFNgɉ̃[t^[Qbg邩?
struct LocalIKMessage_HasAnyMorphTarget{
	//(Ȃ)
	int obj_id;
	//o
	//BOOL ret;								//0:Ȃ,1:
};
//w̃IuWFNgɉ̃[t^[Qbg邩?
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//o)	Ԃl				TRUE:[t^[QbgAFALSE:[t^[QbgȂ
static BOOL LocalIKCmd_HasAnyMorphTargetMax(MQBasePlugin *bp,MQDocument doc,int obj_id){
	LocalIKMessage_HasAnyMorphTarget param;
	param.obj_id=obj_id;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_HASANYMORPHTARGET,&param);
}
//==============================================
//w̃CfbNX̃[t^[Qbg邩?
struct LocalIKMessage_HasMorphTarget{
	//
	int obj_id;
	int morph_index;						//[tIndex
	//o
	//BOOL ret;								//0:Ȃ,1:
};
//w̃IuWFNgɎw̃CfbNX̃[t^[Qbg邩?
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		morph_index			[t^[Qbg̃CfbNX
//o)	Ԃl				TRUE:[t^[QbgAFALSE:[t^[QbgȂ
static BOOL LocalIKCmd_HasMorphTargetMax(MQBasePlugin *bp,MQDocument doc,int obj_id,int morph_index){
	LocalIKMessage_HasMorphTarget param;
	param.obj_id     =obj_id;
	param.morph_index=morph_index;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_HASMORPHTARGET,&param);
}
//==============================================
//[t^[Qbg̐ݒ
struct LocalIKMessage_SetMorphTarget{
	//
	int obj_id;								//IuWFNgID
	char name[256];							//O
	char group[256];						//O[v
	//o
	int morph_index;						//[tIndex
public:
	inline LocalIKMessage_SetMorphTarget(){
		name[0]=0;
		group[0]=0;
	}
};
//w̃IuWFNgɃ[t^[Qbgݒ肷
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		name				[t^[Qbg̖O
//		group				[tO[v̖O
//o)	Ԃl				TRUE:AFALSE:s
//		morph_index			쐬ꂽ[t^[Qbg̃CfbNX
static BOOL LocalIKCmd_SetMorphTarget(MQBasePlugin *bp,MQDocument doc,int obj_id,const char *name,const char *group,int &morph_index){
	LocalIKMessage_SetMorphTarget param;
	param.obj_id     =obj_id;
	if(name)strcpy(param.name,name);
	if(group)strcpy(param.group,group);
	if(!bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_SETMORPHTARGET,&param))return FALSE;
	morph_index=param.morph_index;
	return TRUE;
}
//==============================================
//[t^[Qbg̊l
struct LocalIKMessage_GetMorphTarget{
	//
	int obj_id;								//IuWFNgID
	int morph_index;						//[tIndex
	//o
	char name[256];							//O
	char group[256];						//O[v
public:
	inline LocalIKMessage_GetMorphTarget(){
		name[0]=0;
		group[0]=0;
	}
};
//w̃IuWFNg̃[t^[Qbgl
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		morph_index			쐬ꂽ[t^[Qbg̃CfbNX
//o)	Ԃl				TRUE:AFALSE:s
//		name				[t^[Qbg̖O
//		group				[tO[v̖O
static BOOL LocalIKCmd_GetMorphTarget(MQBasePlugin *bp,MQDocument doc,int obj_id,char *name,int name_len,char *group,int group_len,int &morph_index){
	LocalIKMessage_GetMorphTarget param;
	param.obj_id     =obj_id;
	if(!bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETMORPHTARGET,&param))return FALSE;
	if(name)strcpy(name,param.name);
	if(group)strcpy(group,param.group);
	morph_index=param.morph_index;
	return TRUE;
}
//==============================================
//[t^[Qbg̈ʒuXgݒ
struct LocalIKMessage_SetMorphTargetPosArray{
	//
	int obj_id;								//IuWFNgID
	int morph_index;						//[tIndex
	const MQPoint *posarray;
	//o(Ȃ)
};
//w̃IuWFNg̃[t^[QbgɈʒuXgݒ肷
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		morph_index			[t^[Qbg̃CfbNX
//		MQPoint *posarray	ʒuXg̃|C^(IuWFNg̒_pӂ)
//o)	Ԃl				TRUE:AFALSE:s
static BOOL LocalIKCmd_SetMorphTargetPosArray(MQBasePlugin *bp,MQDocument doc,int obj_id,int morph_index,const MQPoint *posarray){
	LocalIKMessage_SetMorphTargetPosArray param;
	param.obj_id      =obj_id;
	param.morph_index =morph_index;
	param.posarray     =posarray;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_SETMORPHTARGETPOSARRAY,&param);
}
//==============================================
//[t^[Qbg̈ʒuXgl
struct LocalIKMessage_GetMorphTargetPosArray{
	//
	int obj_id;								//IuWFNgID
	int morph_index;						//[tIndex
	//o
	MQPoint *posarray;						//\ߒ_mۂĂ
};
//w̃IuWFNg̃[t^[Qbg̈ʒuXgl
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		morph_index			[t^[Qbg̃CfbNX
//		MQPoint *posarray	l邽߂̈ʒuXg̃|C^(\߃IuWFNg̒_pӂ)
//o)	Ԃl				TRUE:AFALSE:s
//		posarrayɈʒuXgAĂ
static BOOL LocalIKCmd_GetMorphTargetPosArray(MQBasePlugin *bp,MQDocument doc,int obj_id,int morph_index,MQPoint *posarray){
	LocalIKMessage_GetMorphTargetPosArray param;
	param.obj_id      =obj_id;
	param.morph_index =morph_index;
	param.posarray     =posarray;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETMORPHTARGETPOSARRAY,&param);
}
//==============================================
//x[X[t^[Qbg̈ʒuXgl
struct LocalIKMessage_GetBaseMorphTargetPosArray{
	//
	int obj_id;								//IuWFNgID
	//o
	MQPoint *posarray;						//\ߒ_mۂĂ
};
//w̃IuWFNg̃x[X[t^[Qbg̈ʒuXgl
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		MQPoint *posarray	l邽߂̈ʒuXg̃|C^(\߃IuWFNg̒_pӂ)
//o)	Ԃl				TRUE:AFALSE:s
//		posarrayɈʒuXgAĂ
static BOOL LocalIKCmd_GetBaseMorphTargetPosArray(MQBasePlugin *bp,MQDocument doc,int obj_id,MQPoint *posarray){
	LocalIKMessage_GetBaseMorphTargetPosArray param;
	param.obj_id      =obj_id;
	param.posarray     =posarray;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETBASEMORPHTARGETPOSARRAY,&param);
}
//==============================================
//Jg[t^[Qbg̃CfbNX̊l
struct LocalIKMessage_GetCurrentMorphTargetIndex{
	//
	int obj_id;								//IuWFNgID
	//o
	int morph_index;
};
//Jg[t^[Qbg̃CfbNX̊l
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//o)	Ԃl				TRUE:AFALSE:s
//		morph_index			Jg[tCfbNX
static BOOL LocalIKCmd_GetCurrentMorphTargetIndex(MQBasePlugin *bp,MQDocument doc,int obj_id,int &morph_index){
	LocalIKMessage_GetCurrentMorphTargetIndex param;
	param.obj_id      =obj_id;
	if(!bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETCURRENTMORPHTARGETINDEX,&param))return FALSE;
	morph_index=param.morph_index;
	return TRUE;
}
//==============================================
//_EFCg̍őll
struct LocalIKMessage_GetVertexWeightMax{
	//(Ȃ)
	//o
	int vertexweight_max;					//ől
};
//1_̒_EFCg̃^[Qbg̍ő吔mۂ
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//o)	Ԃl				TRUE:AFALSE:s
//		vertexweight_max	1_̒_EFCg̃^[Qbg̍ő吔
static BOOL LocalIKCmd_GetVertexWeightMax(MQBasePlugin *bp,MQDocument doc,int &vertexweight_max){
	LocalIKMessage_GetVertexWeightMax param;
	if(!bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETVERTEXWEIGHTMAX,&param))return FALSE;
	vertexweight_max=param.vertexweight_max;
	return TRUE;
}
//==============================================
//_EFCg?
struct LocalIKMessage_HasVertexWeight{
	//(Ȃ)
	int obj_id;
	//o
	//BOOL ret;								//0:Ȃ,1:
};
//w̃IuWFNg_EFCgĂ邩?
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//o)	Ԃl				TRUE:_EFCgAFALSE:_EFCgȂ
static BOOL LocalIKCmd_HasVertexWeight(MQBasePlugin *bp,MQDocument doc,int obj_id){
	LocalIKMessage_HasVertexWeight param;
	param.obj_id=obj_id;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_HASVERTEXWEIGHT,&param);
}
//==============================================
//_EFCgXg̐ݒ
struct LocalIKMessage_SetVertexWeightArray{
	//
	int obj_id;								//IuWFNgID
	const LocalIKMessage_VertexWeightArray *vwarray;
	//o(Ȃ)
};
//_EFCgXg̐ݒ
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		vwarray				_EFCgXg
//o)	Ԃl				TRUE:AFALSE:s
static BOOL LocalIKCmd_SetVertexWeightArray(MQBasePlugin *bp,MQDocument doc,int obj_id,const LocalIKMessage_VertexWeightArray *vwarray){
	LocalIKMessage_SetVertexWeightArray param;
	param.obj_id      =obj_id;
	param.vwarray      =vwarray;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_SETVERTEXWEIGHTARRAY,&param);
}
//==============================================
//_EFCgXg̊l
struct LocalIKMessage_GetVertexWeightArray{
	//
	int obj_id;								//IuWFNgID
	//o
	LocalIKMessage_VertexWeightArray *vwarray;	//\ߒ_mۂĂ
};
//_EFCgXg̊l
//)	MQBasePlugin *bp	vOC̃x[X|C^
//		MQDocument doc		hLg
//		obj_id				IuWFNgID
//		vwarray				_EFCgXg(\LocalIKMessage_VertexWeightArray::AllocŊmۂĂ)
//o)	Ԃl				TRUE:AFALSE:s
//		vwarrayɒ_EFCgXgԂĂ
static BOOL LocalIKCmd_GetVertexWeightArray(MQBasePlugin *bp,MQDocument doc,int obj_id,LocalIKMessage_VertexWeightArray *vwarray){
	LocalIKMessage_GetVertexWeightArray param;
	param.obj_id      =obj_id;
	param.vwarray      =vwarray;
	return bp->SendUserMessage(doc,LOCALIK_PLUGIN_PRODUCT,LOCALIK_PLUGIN_ID,LOCALIKCMD_GETVERTEXWEIGHTARRAY,&param);
}

/******************************************************************************
;	܂
******************************************************************************/
#endif
